Index: c/src/lib/libbsp/i386/shared/comm/GDB.HOWTO
===================================================================
--- c/src/lib/libbsp/i386/shared/comm/GDB.HOWTO	(revision 0ebbf66b0ee518763ee38b4ac28c7d3b6feaadf1)
+++ c/src/lib/libbsp/i386/shared/comm/GDB.HOWTO	(revision 0ebbf66b0ee518763ee38b4ac28c7d3b6feaadf1)
@@ -0,0 +1,177 @@
+1. Add GDB initilization to your target's code:
+
+a) include file:
+
+#include <uart.h>
+
+b) declare this variable:   
+
+extern int BSPConsolePort;
+
+c) To start-up GDB, run this:
+
+ /* Init GDB glue  */
+
+  if(BSPConsolePort != BSP_UART_COM2)
+    {
+      /*
+       * If com2 is not used as console use it for
+       * debugging
+       */
+      i386_stub_glue_init(BSP_UART_COM2);
+    }
+  else
+    {
+      /* Otherwise use com1 */
+      i386_stub_glue_init(BSP_UART_COM1);
+    }
+
+  /* Init GDB stub itself */
+  set_debug_traps();
+
+  /*
+   * Init GDB break in capability,
+   * has to be called after
+   * set_debug_traps
+   */
+  i386_stub_glue_init_breakin();
+
+  /* Put breakpoint in */
+  breakpoint();
+
+d) This is all you need to do for the target.
+
+2. Edit cmds: specify path to current directory and device used for debugging
+   example of cmds is attached below.  Make sure your paths are correct.
+3. type 'make'
+4. Boot o-pc386/<test>.exe on target computer, where <test> has the code from step 1. ( I modified and recompiled base_sp as the <test> )
+5. run 'i396-rtems-gdb --nx --command=./cmds o-pc386/<test>.coff
+
+=========================== example cmds ==============================
+dir /home/cross-19980908/tools/rtems-980923
+dir /home/cross-19980908/tools/rtems-980923/aclocal
+dir /home/cross-19980908/tools/rtems-980923/c
+dir /home/cross-19980908/tools/rtems-980923/c/build-tools
+dir /home/cross-19980908/tools/rtems-980923/c/build-tools/os
+dir /home/cross-19980908/tools/rtems-980923/c/build-tools/os/msdos
+dir /home/cross-19980908/tools/rtems-980923/c/build-tools/scripts
+dir /home/cross-19980908/tools/rtems-980923/c/build-tools/src
+dir /home/cross-19980908/tools/rtems-980923/c/src
+dir /home/cross-19980908/tools/rtems-980923/c/src/exec
+dir /home/cross-19980908/tools/rtems-980923/c/src/exec/posix
+dir /home/cross-19980908/tools/rtems-980923/c/src/exec/posix/base
+dir /home/cross-19980908/tools/rtems-980923/c/src/exec/posix/headers
+dir /home/cross-19980908/tools/rtems-980923/c/src/exec/posix/inline
+dir /home/cross-19980908/tools/rtems-980923/c/src/exec/posix/macros
+dir /home/cross-19980908/tools/rtems-980923/c/src/exec/posix/optman
+dir /home/cross-19980908/tools/rtems-980923/c/src/exec/posix/src
+dir /home/cross-19980908/tools/rtems-980923/c/src/exec/posix/sys
+dir /home/cross-19980908/tools/rtems-980923/c/src/exec/sapi
+dir /home/cross-19980908/tools/rtems-980923/c/src/exec/sapi/headers
+dir /home/cross-19980908/tools/rtems-980923/c/src/exec/sapi/src
+dir /home/cross-19980908/tools/rtems-980923/c/src/exec/sapi/inline
+dir /home/cross-19980908/tools/rtems-980923/c/src/exec/sapi/macros
+dir /home/cross-19980908/tools/rtems-980923/c/src/exec/sapi/optman
+dir /home/cross-19980908/tools/rtems-980923/c/src/exec/rtems
+dir /home/cross-19980908/tools/rtems-980923/c/src/exec/rtems/headers
+dir /home/cross-19980908/tools/rtems-980923/c/src/exec/rtems/src
+dir /home/cross-19980908/tools/rtems-980923/c/src/exec/rtems/inline
+dir /home/cross-19980908/tools/rtems-980923/c/src/exec/rtems/macros
+dir /home/cross-19980908/tools/rtems-980923/c/src/exec/rtems/optman
+dir /home/cross-19980908/tools/rtems-980923/c/src/exec/score
+dir /home/cross-19980908/tools/rtems-980923/c/src/exec/score/cpu
+dir /home/cross-19980908/tools/rtems-980923/c/src/exec/score/cpu/a29k
+dir /home/cross-19980908/tools/rtems-980923/c/src/exec/score/cpu/hppa1.1
+dir /home/cross-19980908/tools/rtems-980923/c/src/exec/score/cpu/i386
+dir /home/cross-19980908/tools/rtems-980923/c/src/exec/score/cpu/i960
+dir /home/cross-19980908/tools/rtems-980923/c/src/exec/score/cpu/m68k
+dir /home/cross-19980908/tools/rtems-980923/c/src/exec/score/cpu/mips64orion
+dir /home/cross-19980908/tools/rtems-980923/c/src/exec/score/cpu/no_cpu
+dir /home/cross-19980908/tools/rtems-980923/c/src/exec/score/cpu/powerpc
+dir /home/cross-19980908/tools/rtems-980923/c/src/exec/score/cpu/sh
+dir /home/cross-19980908/tools/rtems-980923/c/src/exec/score/cpu/sparc
+dir /home/cross-19980908/tools/rtems-980923/c/src/exec/score/cpu/unix
+dir /home/cross-19980908/tools/rtems-980923/c/src/exec/score/headers
+dir /home/cross-19980908/tools/rtems-980923/c/src/exec/score/inline
+dir /home/cross-19980908/tools/rtems-980923/c/src/exec/score/macros
+dir /home/cross-19980908/tools/rtems-980923/c/src/exec/score/src
+dir /home/cross-19980908/tools/rtems-980923/c/src/exec/score/tools
+dir /home/cross-19980908/tools/rtems-980923/c/src/exec/score/tools/generic
+dir /home/cross-19980908/tools/rtems-980923/c/src/exec/score/tools/unix
+dir /home/cross-19980908/tools/rtems-980923/c/src/exec/score/tools/hppa1.1
+dir /home/cross-19980908/tools/rtems-980923/c/src/exec/wrapup
+dir /home/cross-19980908/tools/rtems-980923/c/src/exec/wrapup/posix
+dir /home/cross-19980908/tools/rtems-980923/c/src/exec/wrapup/rtems
+dir /home/cross-19980908/tools/rtems-980923/c/src/lib
+dir /home/cross-19980908/tools/rtems-980923/c/src/lib/include
+dir /home/cross-19980908/tools/rtems-980923/c/src/lib/include/motorola
+dir /home/cross-19980908/tools/rtems-980923/c/src/lib/include/rtems++
+dir /home/cross-19980908/tools/rtems-980923/c/src/lib/include/sys
+dir /home/cross-19980908/tools/rtems-980923/c/src/lib/include/zilog
+dir /home/cross-19980908/tools/rtems-980923/c/src/lib/libc
+dir /home/cross-19980908/tools/rtems-980923/c/src/lib/libbsp
+dir /home/cross-19980908/tools/rtems-980923/c/src/lib/libbsp/i386
+dir /home/cross-19980908/tools/rtems-980923/c/src/lib/libbsp/i386/pc386
+dir /home/cross-19980908/tools/rtems-980923/c/src/lib/libbsp/i386/pc386/clock
+dir /home/cross-19980908/tools/rtems-980923/c/src/lib/libbsp/i386/pc386/console
+dir /home/cross-19980908/tools/rtems-980923/c/src/lib/libbsp/i386/pc386/include
+dir /home/cross-19980908/tools/rtems-980923/c/src/lib/libbsp/i386/pc386/start
+dir /home/cross-19980908/tools/rtems-980923/c/src/lib/libbsp/i386/pc386/startup
+dir /home/cross-19980908/tools/rtems-980923/c/src/lib/libbsp/i386/pc386/timer
+dir /home/cross-19980908/tools/rtems-980923/c/src/lib/libbsp/i386/pc386/tools
+dir /home/cross-19980908/tools/rtems-980923/c/src/lib/libbsp/i386/pc386/wrapup
+dir /home/cross-19980908/tools/rtems-980923/c/src/lib/libbsp/i386/shared/comm
+dir /home/cross-19980908/tools/rtems-980923/c/src/lib/libbsp/i386/shared/pci
+dir /home/cross-19980908/tools/rtems-980923/c/src/lib/libcpu
+dir /home/cross-19980908/tools/rtems-980923/c/src/lib/libcpu/hppa1.1
+dir /home/cross-19980908/tools/rtems-980923/c/src/lib/libcpu/hppa1.1/clock
+dir /home/cross-19980908/tools/rtems-980923/c/src/lib/libcpu/hppa1.1/include
+dir /home/cross-19980908/tools/rtems-980923/c/src/lib/libcpu/hppa1.1/milli
+dir /home/cross-19980908/tools/rtems-980923/c/src/lib/libcpu/hppa1.1/runway
+dir /home/cross-19980908/tools/rtems-980923/c/src/lib/libcpu/hppa1.1/semaphore
+dir /home/cross-19980908/tools/rtems-980923/c/src/lib/libcpu/hppa1.1/timer
+dir /home/cross-19980908/tools/rtems-980923/c/src/lib/libcpu/m68k
+dir /home/cross-19980908/tools/rtems-980923/c/src/lib/libcpu/m68k/m68040
+dir /home/cross-19980908/tools/rtems-980923/c/src/lib/libcpu/m68k/m68040/fpsp
+dir /home/cross-19980908/tools/rtems-980923/c/src/lib/libcpu/mips64orion
+dir /home/cross-19980908/tools/rtems-980923/c/src/lib/libcpu/mips64orion/clock
+dir /home/cross-19980908/tools/rtems-980923/c/src/lib/libcpu/mips64orion/include
+dir /home/cross-19980908/tools/rtems-980923/c/src/lib/libcpu/mips64orion/timer
+dir /home/cross-19980908/tools/rtems-980923/c/src/lib/libcpu/powerpc
+dir /home/cross-19980908/tools/rtems-980923/c/src/lib/libcpu/powerpc/ppc403
+dir /home/cross-19980908/tools/rtems-980923/c/src/lib/libcpu/powerpc/ppc403/clock
+dir /home/cross-19980908/tools/rtems-980923/c/src/lib/libcpu/powerpc/ppc403/console
+dir /home/cross-19980908/tools/rtems-980923/c/src/lib/libcpu/powerpc/ppc403/include
+dir /home/cross-19980908/tools/rtems-980923/c/src/lib/libcpu/powerpc/ppc403/timer
+dir /home/cross-19980908/tools/rtems-980923/c/src/lib/libcpu/powerpc/ppc403/vectors
+dir /home/cross-19980908/tools/rtems-980923/c/src/lib/libcpu/sh
+dir /home/cross-19980908/tools/rtems-980923/c/src/lib/libcpu/sh/sh7032
+dir /home/cross-19980908/tools/rtems-980923/c/src/lib/libcpu/sh/sh7032/clock
+dir /home/cross-19980908/tools/rtems-980923/c/src/lib/libcpu/sh/sh7032/null
+dir /home/cross-19980908/tools/rtems-980923/c/src/lib/libcpu/sh/sh7032/console
+dir /home/cross-19980908/tools/rtems-980923/c/src/lib/libcpu/sh/sh7032/include
+dir /home/cross-19980908/tools/rtems-980923/c/src/lib/libcpu/sh/sh7032/timer
+dir /home/cross-19980908/tools/rtems-980923/c/src/lib/libcpu/sparc
+dir /home/cross-19980908/tools/rtems-980923/c/src/lib/libcpu/sparc/reg_win
+dir /home/cross-19980908/tools/rtems-980923/c/src/lib/libnetworking
+dir /home/cross-19980908/tools/rtems-980923/c/src/lib/libmisc
+dir /home/cross-19980908/tools/rtems-980923/c/src/lib/libmisc/assoc
+dir /home/cross-19980908/tools/rtems-980923/c/src/lib/libmisc/cpuuse
+dir /home/cross-19980908/tools/rtems-980923/c/src/lib/libmisc/error
+dir /home/cross-19980908/tools/rtems-980923/c/src/lib/libmisc/monitor
+dir /home/cross-19980908/tools/rtems-980923/c/src/lib/libmisc/rtmonuse
+dir /home/cross-19980908/tools/rtems-980923/c/src/lib/libmisc/stackchk
+dir /home/cross-19980908/tools/rtems-980923/c/src/lib/libmisc/wrapup
+dir /home/cross-19980908/tools/rtems-980923/c/src/lib/librtems++
+dir /home/cross-19980908/tools/rtems-980923/c/src/lib/start
+dir /home/cross-19980908/tools/rtems-980923/c/src/lib/start/a29k
+dir /home/cross-19980908/tools/rtems-980923/c/src/lib/start/i960
+dir /home/cross-19980908/tools/rtems-980923/c/src/lib/start/m68k
+dir /home/cross-19980908/tools/rtems-980923/c/src/lib/start/mips64orion
+dir /home/cross-19980908/tools/rtems-980923/c/src/lib/start/sh
+dir /home/cross-19980908/tools/rtems-980923/c/src/lib/wrapup
+dir /home/cross-19980908/tools/rtems-980923/c/src/tests
+dir /home/cross-19980908/tools/rtems-980923/c/src/tests/samples
+dir /home/cross-19980908/tools/rtems-980923/c/src/tests/samples/base_sp
+set remotebaud 38400
+target remote /dev/ttyS1
Index: c/src/lib/libbsp/i386/shared/comm/i386-stub-glue.c
===================================================================
--- c/src/lib/libbsp/i386/shared/comm/i386-stub-glue.c	(revision 0ebbf66b0ee518763ee38b4ac28c7d3b6feaadf1)
+++ c/src/lib/libbsp/i386/shared/comm/i386-stub-glue.c	(revision 0ebbf66b0ee518763ee38b4ac28c7d3b6feaadf1)
@@ -0,0 +1,194 @@
+/*
+ * This software is Copyright (C) 1998 by T.sqware - all rights limited
+ * It is provided in to the public domain "as is", can be freely modified
+ * as far as this copyight notice is kept unchanged, but does not imply
+ * an endorsement by T.sqware of the product in which it is included.
+ *
+ *  $Id$
+ */
+
+#include <rtems/system.h>
+#include <rtems/score/cpu.h>
+#include <bsp.h>
+#include <irq.h>
+#include <uart.h>
+#include <assert.h>
+
+
+int  putDebugChar(int ch);     /* write a single character      */
+int  getDebugChar(void);       /* read and return a single char */
+
+/* assign an exception handler */
+void exceptionHandler(int, void (*handler)(void));   
+
+
+/* Current uart used by gdb stub */
+static int uart_current = 0;
+
+/*
+ * Initialize glue code linking i386-stub with the rest of
+ * the system
+ */
+void
+i386_stub_glue_init(int uart)
+{
+  assert(uart == BSP_UART_COM1 || uart == BSP_UART_COM2);
+
+  uart_current = uart;
+
+  BSP_uart_init(uart, 38400, 0); 
+}
+
+void BSP_uart_on(const rtems_raw_irq_connect_data* used)
+{
+  BSP_irq_enable_at_i8259s(used->idtIndex - BSP_IRQ_VECTOR_BASE);
+}
+
+void BSP_uart_off(const rtems_raw_irq_connect_data* used)
+{
+  BSP_irq_disable_at_i8259s(used->idtIndex - BSP_IRQ_VECTOR_BASE);
+}
+
+int BSP_uart_isOn(const rtems_raw_irq_connect_data* used)
+{
+  return BSP_irq_enabled_at_i8259s(used->idtIndex - BSP_IRQ_VECTOR_BASE);
+}
+
+
+/*
+ * In order to have a possibility to break into 
+ * running program, one has to call this function
+ */
+void i386_stub_glue_init_breakin(void)
+{
+  rtems_raw_irq_connect_data uart_raw_irq_data;
+
+  assert(uart_current == BSP_UART_COM1 || uart_current == BSP_UART_COM2);
+
+  if(uart_current == BSP_UART_COM1)
+    {
+      uart_raw_irq_data.idtIndex = BSP_UART_COM1_IRQ + BSP_IRQ_VECTOR_BASE;
+    }
+  else
+    {
+      uart_raw_irq_data.idtIndex = BSP_UART_COM2_IRQ + BSP_IRQ_VECTOR_BASE;
+    }
+
+  if(!i386_get_current_idt_entry(&uart_raw_irq_data)) 
+    {
+      printk("cannot get idt entry\n");
+      rtems_fatal_error_occurred(1);
+    }
+
+  if(!i386_delete_idt_entry(&uart_raw_irq_data)) 
+    {
+      printk("cannot delete idt entry\n");
+      rtems_fatal_error_occurred(1);
+    }
+
+  uart_raw_irq_data.on  = BSP_uart_on;
+  uart_raw_irq_data.off = BSP_uart_off;
+  uart_raw_irq_data.isOn= BSP_uart_isOn;
+
+  /* Install ISR  */
+  if(uart_current == BSP_UART_COM1)
+    {
+      uart_raw_irq_data.idtIndex = BSP_UART_COM1_IRQ + BSP_IRQ_VECTOR_BASE;
+      uart_raw_irq_data.hdl = BSP_uart_dbgisr_com1;
+    }
+  else
+    {
+      uart_raw_irq_data.idtIndex = BSP_UART_COM2_IRQ + BSP_IRQ_VECTOR_BASE;
+      uart_raw_irq_data.hdl = BSP_uart_dbgisr_com2;
+    }
+
+  if (!i386_set_idt_entry (&uart_raw_irq_data)) 
+    {
+      printk("raw exception handler connection failed\n");
+      rtems_fatal_error_occurred(1);
+    }
+  
+  /* Enable interrupts */
+  BSP_uart_intr_ctrl(uart_current, BSP_UART_INTR_CTRL_GDB);
+
+  return;
+}
+
+
+int
+putDebugChar(int ch)
+{
+  assert(uart_current == BSP_UART_COM1 || uart_current == BSP_UART_COM2);
+
+  BSP_uart_polled_write(uart_current, ch);
+
+  return 1;
+}
+
+int getDebugChar(void)
+{
+  int val;
+
+  assert(uart_current == BSP_UART_COM1 || uart_current == BSP_UART_COM2);
+
+  val = BSP_uart_polled_read(uart_current);
+
+  return val;
+}
+
+static void nop(){}
+static int isOn() {return 1;}
+
+void exceptionHandler(int vector, void (*handler)(void))
+{
+  rtems_raw_irq_connect_data excep_raw_irq_data;
+
+  excep_raw_irq_data.idtIndex = vector;
+
+  if(!i386_get_current_idt_entry(&excep_raw_irq_data)) 
+    {
+      printk("cannot get idt entry\n");
+      rtems_fatal_error_occurred(1);
+    }
+
+  if(!i386_delete_idt_entry(&excep_raw_irq_data)) 
+    {
+      printk("cannot delete idt entry\n");
+      rtems_fatal_error_occurred(1);
+    }
+
+  excep_raw_irq_data.on = nop;
+  excep_raw_irq_data.off = nop;
+  excep_raw_irq_data.isOn = isOn;
+  excep_raw_irq_data.hdl = handler;
+
+  if (!i386_set_idt_entry (&excep_raw_irq_data)) {
+      printk("raw exception handler connection failed\n");
+      rtems_fatal_error_occurred(1);
+    }
+  return;
+}
+
+
+
+  
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
